package b4a.example;


import anywheresoftware.b4a.B4AMenuItem;
import android.app.Activity;
import android.os.Bundle;
import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.BALayout;
import anywheresoftware.b4a.B4AActivity;
import anywheresoftware.b4a.ObjectWrapper;
import anywheresoftware.b4a.objects.ActivityWrapper;
import java.lang.reflect.InvocationTargetException;
import anywheresoftware.b4a.B4AUncaughtException;
import anywheresoftware.b4a.debug.*;
import java.lang.ref.WeakReference;

public class main extends Activity implements B4AActivity{
	public static main mostCurrent;
	static boolean afterFirstLayout;
	static boolean isFirst = true;
    private static boolean processGlobalsRun = false;
	BALayout layout;
	public static BA processBA;
	BA activityBA;
    ActivityWrapper _activity;
    java.util.ArrayList<B4AMenuItem> menuItems;
	public static final boolean fullScreen = false;
	public static final boolean includeTitle = true;
    public static WeakReference<Activity> previousOne;

	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		if (isFirst) {
			processBA = new anywheresoftware.b4a.ShellBA(this.getApplicationContext(), null, null, "b4a.example", "b4a.example.main");
			processBA.loadHtSubs(this.getClass());
	        float deviceScale = getApplicationContext().getResources().getDisplayMetrics().density;
	        BALayout.setDeviceScale(deviceScale);
            
		}
		else if (previousOne != null) {
			Activity p = previousOne.get();
			if (p != null && p != this) {
                BA.LogInfo("Killing previous instance (main).");
				p.finish();
			}
		}
        processBA.runHook("oncreate", this, null);
		if (!includeTitle) {
        	this.getWindow().requestFeature(android.view.Window.FEATURE_NO_TITLE);
        }
        if (fullScreen) {
        	getWindow().setFlags(android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN,   
        			android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN);
        }
		mostCurrent = this;
        processBA.sharedProcessBA.activityBA = null;
		layout = new BALayout(this);
		setContentView(layout);
		afterFirstLayout = false;
        WaitForLayout wl = new WaitForLayout();
        if (anywheresoftware.b4a.objects.ServiceHelper.StarterHelper.startFromActivity(processBA, wl, true))
		    BA.handler.postDelayed(wl, 5);

	}
	static class WaitForLayout implements Runnable {
		public void run() {
			if (afterFirstLayout)
				return;
			if (mostCurrent == null)
				return;
            
			if (mostCurrent.layout.getWidth() == 0) {
				BA.handler.postDelayed(this, 5);
				return;
			}
			mostCurrent.layout.getLayoutParams().height = mostCurrent.layout.getHeight();
			mostCurrent.layout.getLayoutParams().width = mostCurrent.layout.getWidth();
			afterFirstLayout = true;
			mostCurrent.afterFirstLayout();
		}
	}
	private void afterFirstLayout() {
        if (this != mostCurrent)
			return;
		activityBA = new BA(this, layout, processBA, "b4a.example", "b4a.example.main");
        
        processBA.sharedProcessBA.activityBA = new java.lang.ref.WeakReference<BA>(activityBA);
        anywheresoftware.b4a.objects.ViewWrapper.lastId = 0;
        _activity = new ActivityWrapper(activityBA, "activity");
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        if (BA.isShellModeRuntimeCheck(processBA)) {
			if (isFirst)
				processBA.raiseEvent2(null, true, "SHELL", false);
			processBA.raiseEvent2(null, true, "CREATE", true, "b4a.example.main", processBA, activityBA, _activity, anywheresoftware.b4a.keywords.Common.Density, mostCurrent);
			_activity.reinitializeForShell(activityBA, "activity");
		}
        initializeProcessGlobals();		
        initializeGlobals();
        
        BA.LogInfo("** Activity (main) Create, isFirst = " + isFirst + " **");
        processBA.raiseEvent2(null, true, "activity_create", false, isFirst);
		isFirst = false;
		if (this != mostCurrent)
			return;
        processBA.setActivityPaused(false);
        BA.LogInfo("** Activity (main) Resume **");
        processBA.raiseEvent(null, "activity_resume");
        if (android.os.Build.VERSION.SDK_INT >= 11) {
			try {
				android.app.Activity.class.getMethod("invalidateOptionsMenu").invoke(this,(Object[]) null);
			} catch (Exception e) {
				e.printStackTrace();
			}
		}

	}
	public void addMenuItem(B4AMenuItem item) {
		if (menuItems == null)
			menuItems = new java.util.ArrayList<B4AMenuItem>();
		menuItems.add(item);
	}
	@Override
	public boolean onCreateOptionsMenu(android.view.Menu menu) {
		super.onCreateOptionsMenu(menu);
        try {
            if (processBA.subExists("activity_actionbarhomeclick")) {
                Class.forName("android.app.ActionBar").getMethod("setHomeButtonEnabled", boolean.class).invoke(
                    getClass().getMethod("getActionBar").invoke(this), true);
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
        if (processBA.runHook("oncreateoptionsmenu", this, new Object[] {menu}))
            return true;
		if (menuItems == null)
			return false;
		for (B4AMenuItem bmi : menuItems) {
			android.view.MenuItem mi = menu.add(bmi.title);
			if (bmi.drawable != null)
				mi.setIcon(bmi.drawable);
            if (android.os.Build.VERSION.SDK_INT >= 11) {
				try {
                    if (bmi.addToBar) {
				        android.view.MenuItem.class.getMethod("setShowAsAction", int.class).invoke(mi, 1);
                    }
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
			mi.setOnMenuItemClickListener(new B4AMenuItemsClickListener(bmi.eventName.toLowerCase(BA.cul)));
		}
        
		return true;
	}   
 @Override
 public boolean onOptionsItemSelected(android.view.MenuItem item) {
    if (item.getItemId() == 16908332) {
        processBA.raiseEvent(null, "activity_actionbarhomeclick");
        return true;
    }
    else
        return super.onOptionsItemSelected(item); 
}
@Override
 public boolean onPrepareOptionsMenu(android.view.Menu menu) {
    super.onPrepareOptionsMenu(menu);
    processBA.runHook("onprepareoptionsmenu", this, new Object[] {menu});
    return true;
    
 }
 protected void onStart() {
    super.onStart();
    processBA.runHook("onstart", this, null);
}
 protected void onStop() {
    super.onStop();
    processBA.runHook("onstop", this, null);
}
    public void onWindowFocusChanged(boolean hasFocus) {
       super.onWindowFocusChanged(hasFocus);
       if (processBA.subExists("activity_windowfocuschanged"))
           processBA.raiseEvent2(null, true, "activity_windowfocuschanged", false, hasFocus);
    }
	private class B4AMenuItemsClickListener implements android.view.MenuItem.OnMenuItemClickListener {
		private final String eventName;
		public B4AMenuItemsClickListener(String eventName) {
			this.eventName = eventName;
		}
		public boolean onMenuItemClick(android.view.MenuItem item) {
			processBA.raiseEvent(item.getTitle(), eventName + "_click");
			return true;
		}
	}
    public static Class<?> getObject() {
		return main.class;
	}
    private Boolean onKeySubExist = null;
    private Boolean onKeyUpSubExist = null;
	@Override
	public boolean onKeyDown(int keyCode, android.view.KeyEvent event) {
		if (onKeySubExist == null)
			onKeySubExist = processBA.subExists("activity_keypress");
		if (onKeySubExist) {
			if (keyCode == anywheresoftware.b4a.keywords.constants.KeyCodes.KEYCODE_BACK &&
					android.os.Build.VERSION.SDK_INT >= 18) {
				HandleKeyDelayed hk = new HandleKeyDelayed();
				hk.kc = keyCode;
				BA.handler.post(hk);
				return true;
			}
			else {
				boolean res = new HandleKeyDelayed().runDirectly(keyCode);
				if (res)
					return true;
			}
		}
		return super.onKeyDown(keyCode, event);
	}
	private class HandleKeyDelayed implements Runnable {
		int kc;
		public void run() {
			runDirectly(kc);
		}
		public boolean runDirectly(int keyCode) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keypress", false, keyCode);
			if (res == null || res == true) {
                return true;
            }
            else if (keyCode == anywheresoftware.b4a.keywords.constants.KeyCodes.KEYCODE_BACK) {
				finish();
				return true;
			}
            return false;
		}
		
	}
    @Override
	public boolean onKeyUp(int keyCode, android.view.KeyEvent event) {
		if (onKeyUpSubExist == null)
			onKeyUpSubExist = processBA.subExists("activity_keyup");
		if (onKeyUpSubExist) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keyup", false, keyCode);
			if (res == null || res == true)
				return true;
		}
		return super.onKeyUp(keyCode, event);
	}
	@Override
	public void onNewIntent(android.content.Intent intent) {
        super.onNewIntent(intent);
		this.setIntent(intent);
        processBA.runHook("onnewintent", this, new Object[] {intent});
	}
    @Override 
	public void onPause() {
		super.onPause();
        if (_activity == null) //workaround for emulator bug (Issue 2423)
            return;
		anywheresoftware.b4a.Msgbox.dismiss(true);
        BA.LogInfo("** Activity (main) Pause, UserClosed = " + activityBA.activity.isFinishing() + " **");
        processBA.raiseEvent2(_activity, true, "activity_pause", false, activityBA.activity.isFinishing());		
        processBA.setActivityPaused(true);
        mostCurrent = null;
        if (!activityBA.activity.isFinishing())
			previousOne = new WeakReference<Activity>(this);
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        processBA.runHook("onpause", this, null);
	}

	@Override
	public void onDestroy() {
        super.onDestroy();
		previousOne = null;
        processBA.runHook("ondestroy", this, null);
	}
    @Override 
	public void onResume() {
		super.onResume();
        mostCurrent = this;
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        if (activityBA != null) { //will be null during activity create (which waits for AfterLayout).
        	ResumeMessage rm = new ResumeMessage(mostCurrent);
        	BA.handler.post(rm);
        }
        processBA.runHook("onresume", this, null);
	}
    private static class ResumeMessage implements Runnable {
    	private final WeakReference<Activity> activity;
    	public ResumeMessage(Activity activity) {
    		this.activity = new WeakReference<Activity>(activity);
    	}
		public void run() {
			if (mostCurrent == null || mostCurrent != activity.get())
				return;
			processBA.setActivityPaused(false);
            BA.LogInfo("** Activity (main) Resume **");
		    processBA.raiseEvent(mostCurrent._activity, "activity_resume", (Object[])null);
		}
    }
	@Override
	protected void onActivityResult(int requestCode, int resultCode,
	      android.content.Intent data) {
		processBA.onActivityResult(requestCode, resultCode, data);
        processBA.runHook("onactivityresult", this, new Object[] {requestCode, resultCode});
	}
	private static void initializeGlobals() {
		processBA.raiseEvent2(null, true, "globals", false, (Object[])null);
	}



public static void initializeProcessGlobals() {
    
    if (main.processGlobalsRun == false) {
	    main.processGlobalsRun = true;
		try {
		        		
        } catch (Exception e) {
			throw new RuntimeException(e);
		}
    }
}
public static boolean isAnyActivityVisible() {
    boolean vis = false;
vis = vis | (main.mostCurrent != null);
return vis;}

public static void killProgram() {
     {
            Activity __a = null;
            if (main.previousOne != null) {
				__a = main.previousOne.get();
			}
            else {
                BA ba = main.mostCurrent.processBA.sharedProcessBA.activityBA.get();
                if (ba != null) __a = ba.activity;
            }
            if (__a != null)
				__a.finish();}

}
public anywheresoftware.b4a.keywords.Common __c = null;
public static anywheresoftware.b4a.objects.BleManager _manager = null;
public static anywheresoftware.b4a.objects.BleManager.GattCharacteristic _readcharacteristic = null;
public static anywheresoftware.b4a.objects.BleManager.GattCharacteristic _writecharacteristic = null;
public static anywheresoftware.b4a.objects.BleManager.GattServiceWrapper _bleservice = null;
public static anywheresoftware.b4a.objects.Timer _timer1 = null;
public anywheresoftware.b4a.objects.collections.List _listbledevicesname = null;
public anywheresoftware.b4a.objects.collections.List _listbledevicesmacadress = null;
public static int _connectstate = 0;
public static int _cstatedisconnect = 0;
public static int _cstatepreconnect = 0;
public static int _cstateconnect = 0;
public anywheresoftware.b4a.objects.LabelWrapper _rx = null;
public anywheresoftware.b4a.objects.ButtonWrapper _tx = null;
public anywheresoftware.b4a.objects.EditTextWrapper _edittext1 = null;
public anywheresoftware.b4a.objects.ButtonWrapper _btndisconnect = null;
public static int _send_t = 0;
public static int _send_max = 0;
public static int _send_code = 0;
public anywheresoftware.b4a.objects.EditTextWrapper _edittext2 = null;
public anywheresoftware.b4a.objects.ButtonWrapper _send4 = null;
public anywheresoftware.b4a.objects.ButtonWrapper _btnstar = null;
public anywheresoftware.b4a.objects.ButtonWrapper _btnstop = null;
public anywheresoftware.b4a.objects.ButtonWrapper _btnf2 = null;
public anywheresoftware.b4a.objects.ButtonWrapper _btnf3 = null;
public anywheresoftware.b4a.objects.EditTextWrapper _edittext4 = null;
public anywheresoftware.b4a.objects.EditTextWrapper _edittext5 = null;
public anywheresoftware.b4a.objects.ButtonWrapper _btnf1 = null;
public anywheresoftware.b4a.objects.EditTextWrapper _edittext3 = null;
public anywheresoftware.b4a.objects.ButtonWrapper _pwroff = null;
public static String  _activity_create(boolean _firsttime) throws Exception{
RDebugUtils.currentModule="main";
if (Debug.shouldDelegate("activity_create"))
	return (String) Debug.delegate(mostCurrent.activityBA, "activity_create", new Object[] {_firsttime});
RDebugUtils.currentLine=131072;
 //BA.debugLineNum = 131072;BA.debugLine="Sub Activity_Create(FirstTime As Boolean)";
RDebugUtils.currentLine=131073;
 //BA.debugLineNum = 131073;BA.debugLine="Activity.LoadLayout(\"Layout1\")";
mostCurrent._activity.LoadLayout("Layout1",mostCurrent.activityBA);
RDebugUtils.currentLine=131075;
 //BA.debugLineNum = 131075;BA.debugLine="listBLEDevicesName.Initialize";
mostCurrent._listbledevicesname.Initialize();
RDebugUtils.currentLine=131076;
 //BA.debugLineNum = 131076;BA.debugLine="listBLEDevicesMacAdress.Initialize";
mostCurrent._listbledevicesmacadress.Initialize();
RDebugUtils.currentLine=131077;
 //BA.debugLineNum = 131077;BA.debugLine="Activity.AddMenuItem(\"Connect\", \"connectBT\")";
mostCurrent._activity.AddMenuItem("Connect","connectBT");
RDebugUtils.currentLine=131078;
 //BA.debugLineNum = 131078;BA.debugLine="timer1.Initialize(\"timer1\",100)";
_timer1.Initialize(processBA,"timer1",(long) (100));
RDebugUtils.currentLine=131079;
 //BA.debugLineNum = 131079;BA.debugLine="timer1.Enabled = True";
_timer1.setEnabled(anywheresoftware.b4a.keywords.Common.True);
RDebugUtils.currentLine=131080;
 //BA.debugLineNum = 131080;BA.debugLine="RX.TextSize = 12";
mostCurrent._rx.setTextSize((float) (12));
RDebugUtils.currentLine=131083;
 //BA.debugLineNum = 131083;BA.debugLine="Try";
try {RDebugUtils.currentLine=131084;
 //BA.debugLineNum = 131084;BA.debugLine="Manager.Initialize(\"BLE\")";
_manager.Initialize(processBA,"BLE");
 } 
       catch (Exception e47) {
			processBA.setLastException(e47);RDebugUtils.currentLine=131086;
 //BA.debugLineNum = 131086;BA.debugLine="Log(\"Error create service : \" & LastException.Me";
anywheresoftware.b4a.keywords.Common.Log("Error create service : "+anywheresoftware.b4a.keywords.Common.LastException(mostCurrent.activityBA).getMessage());
 };
RDebugUtils.currentLine=131088;
 //BA.debugLineNum = 131088;BA.debugLine="If ConnectState = cstateDisconnect Then";
if (_connectstate==_cstatedisconnect) { 
RDebugUtils.currentLine=131089;
 //BA.debugLineNum = 131089;BA.debugLine="connectBT_Click";
_connectbt_click();
 };
RDebugUtils.currentLine=131092;
 //BA.debugLineNum = 131092;BA.debugLine="End Sub";
return "";
}
public static String  _connectbt_click() throws Exception{
RDebugUtils.currentModule="main";
if (Debug.shouldDelegate("connectbt_click"))
	return (String) Debug.delegate(mostCurrent.activityBA, "connectbt_click", null);
RDebugUtils.currentLine=720896;
 //BA.debugLineNum = 720896;BA.debugLine="Sub connectBT_Click";
RDebugUtils.currentLine=720897;
 //BA.debugLineNum = 720897;BA.debugLine="Log(\"Searching devices...\")";
anywheresoftware.b4a.keywords.Common.Log("Searching devices...");
RDebugUtils.currentLine=720898;
 //BA.debugLineNum = 720898;BA.debugLine="Manager.StopRssiTracking";
_manager.StopRssiTracking();
RDebugUtils.currentLine=720899;
 //BA.debugLineNum = 720899;BA.debugLine="Manager.Disconnect";
_manager.Disconnect();
RDebugUtils.currentLine=720900;
 //BA.debugLineNum = 720900;BA.debugLine="ConnectState = cstateDisconnect";
_connectstate = _cstatedisconnect;
RDebugUtils.currentLine=720901;
 //BA.debugLineNum = 720901;BA.debugLine="If (Manager.BleSupported) Then";
if ((_manager.getBleSupported())) { 
RDebugUtils.currentLine=720902;
 //BA.debugLineNum = 720902;BA.debugLine="Manager.Scan(3000, Null)";
_manager.Scan(processBA,(long) (3000),(String[])(anywheresoftware.b4a.keywords.Common.Null));
 }else {
RDebugUtils.currentLine=720904;
 //BA.debugLineNum = 720904;BA.debugLine="Msgbox2(\"Bluetooth 4 (BLE) not found !\", \"Error\"";
anywheresoftware.b4a.keywords.Common.Msgbox2("Bluetooth 4 (BLE) not found !","Error","OK","","",(android.graphics.Bitmap)(anywheresoftware.b4a.keywords.Common.LoadBitmap(anywheresoftware.b4a.keywords.Common.File.getDirAssets(),"error.png").getObject()),mostCurrent.activityBA);
 };
RDebugUtils.currentLine=720906;
 //BA.debugLineNum = 720906;BA.debugLine="listBLEDevicesName.clear";
mostCurrent._listbledevicesname.Clear();
RDebugUtils.currentLine=720907;
 //BA.debugLineNum = 720907;BA.debugLine="listBLEDevicesMacAdress.clear";
mostCurrent._listbledevicesmacadress.Clear();
RDebugUtils.currentLine=720908;
 //BA.debugLineNum = 720908;BA.debugLine="ToastMessageShow( \"Searching devices...\" ,True)";
anywheresoftware.b4a.keywords.Common.ToastMessageShow("Searching devices...",anywheresoftware.b4a.keywords.Common.True);
RDebugUtils.currentLine=720909;
 //BA.debugLineNum = 720909;BA.debugLine="End Sub";
return "";
}
public static String  _activity_pause(boolean _userclosed) throws Exception{
RDebugUtils.currentModule="main";
if (Debug.shouldDelegate("activity_pause"))
	return (String) Debug.delegate(mostCurrent.activityBA, "activity_pause", new Object[] {_userclosed});
RDebugUtils.currentLine=262144;
 //BA.debugLineNum = 262144;BA.debugLine="Sub Activity_Pause (UserClosed As Boolean)";
RDebugUtils.currentLine=262145;
 //BA.debugLineNum = 262145;BA.debugLine="btnStop_Click";
_btnstop_click();
RDebugUtils.currentLine=262146;
 //BA.debugLineNum = 262146;BA.debugLine="Manager.Disconnect";
_manager.Disconnect();
RDebugUtils.currentLine=262147;
 //BA.debugLineNum = 262147;BA.debugLine="Activity.Finish";
mostCurrent._activity.Finish();
RDebugUtils.currentLine=262148;
 //BA.debugLineNum = 262148;BA.debugLine="End Sub";
return "";
}
public static String  _btnstop_click() throws Exception{
RDebugUtils.currentModule="main";
if (Debug.shouldDelegate("btnstop_click"))
	return (String) Debug.delegate(mostCurrent.activityBA, "btnstop_click", null);
RDebugUtils.currentLine=1572864;
 //BA.debugLineNum = 1572864;BA.debugLine="Sub btnStop_Click";
RDebugUtils.currentLine=1572865;
 //BA.debugLineNum = 1572865;BA.debugLine="EditText1.Text = \"10,*\"";
mostCurrent._edittext1.setText((Object)("10,*"));
RDebugUtils.currentLine=1572866;
 //BA.debugLineNum = 1572866;BA.debugLine="TX_Click";
_tx_click();
RDebugUtils.currentLine=1572867;
 //BA.debugLineNum = 1572867;BA.debugLine="End Sub";
return "";
}
public static String  _activity_resume() throws Exception{
RDebugUtils.currentModule="main";
if (Debug.shouldDelegate("activity_resume"))
	return (String) Debug.delegate(mostCurrent.activityBA, "activity_resume", null);
RDebugUtils.currentLine=196608;
 //BA.debugLineNum = 196608;BA.debugLine="Sub Activity_Resume";
RDebugUtils.currentLine=196610;
 //BA.debugLineNum = 196610;BA.debugLine="End Sub";
return "";
}
public static String  _ble_characteristicchanged(anywheresoftware.b4a.objects.BleManager.GattCharacteristic _characteristic) throws Exception{
RDebugUtils.currentModule="main";
if (Debug.shouldDelegate("ble_characteristicchanged"))
	return (String) Debug.delegate(mostCurrent.activityBA, "ble_characteristicchanged", new Object[] {_characteristic});
RDebugUtils.currentLine=1048576;
 //BA.debugLineNum = 1048576;BA.debugLine="Sub ble_CharacteristicChanged (Characteristic As B";
RDebugUtils.currentLine=1048577;
 //BA.debugLineNum = 1048577;BA.debugLine="Log(\"Read -> \" & Characteristic.GetStringValue(0)";
anywheresoftware.b4a.keywords.Common.Log("Read -> "+_characteristic.GetStringValue((int) (0)));
RDebugUtils.currentLine=1048584;
 //BA.debugLineNum = 1048584;BA.debugLine="RX.Text = RX.Text & Characteristic.GetStringValue";
mostCurrent._rx.setText((Object)(mostCurrent._rx.getText()+_characteristic.GetStringValue((int) (0))+anywheresoftware.b4a.keywords.Common.CRLF));
RDebugUtils.currentLine=1048586;
 //BA.debugLineNum = 1048586;BA.debugLine="End Sub";
return "";
}
public static String  _ble_connected(anywheresoftware.b4a.objects.collections.Map _services) throws Exception{
RDebugUtils.currentModule="main";
if (Debug.shouldDelegate("ble_connected"))
	return (String) Debug.delegate(mostCurrent.activityBA, "ble_connected", new Object[] {_services});
RDebugUtils.currentLine=917504;
 //BA.debugLineNum = 917504;BA.debugLine="Sub ble_Connected (Services As Map)";
RDebugUtils.currentLine=917505;
 //BA.debugLineNum = 917505;BA.debugLine="If ConnectState = cstatePreConnect Then";
if (_connectstate==_cstatepreconnect) { 
RDebugUtils.currentLine=917506;
 //BA.debugLineNum = 917506;BA.debugLine="ConnectState = cstateConnect";
_connectstate = _cstateconnect;
RDebugUtils.currentLine=917507;
 //BA.debugLineNum = 917507;BA.debugLine="bleService = Services.GetValueAt(2)";
_bleservice.setObject((android.bluetooth.BluetoothGattService)(_services.GetValueAt((int) (2))));
RDebugUtils.currentLine=917508;
 //BA.debugLineNum = 917508;BA.debugLine="readCharacteristic = bleService.GetCharacteri";
_readcharacteristic.setObject((android.bluetooth.BluetoothGattCharacteristic)(_bleservice.GetCharacteristics().GetValueAt((int) (0))));
RDebugUtils.currentLine=917509;
 //BA.debugLineNum = 917509;BA.debugLine="Manager.ReadCharacteristic(readCharacteristic";
_manager.ReadCharacteristic(_readcharacteristic);
RDebugUtils.currentLine=917510;
 //BA.debugLineNum = 917510;BA.debugLine="Manager.SetCharacteristicNotification(readCha";
_manager.SetCharacteristicNotification(_readcharacteristic,anywheresoftware.b4a.keywords.Common.True);
RDebugUtils.currentLine=917511;
 //BA.debugLineNum = 917511;BA.debugLine="writeCharacteristic = bleService.GetCharacter";
_writecharacteristic.setObject((android.bluetooth.BluetoothGattCharacteristic)(_bleservice.GetCharacteristics().GetValueAt((int) (0))));
 };
RDebugUtils.currentLine=917514;
 //BA.debugLineNum = 917514;BA.debugLine="End Sub";
return "";
}
public static String  _ble_devicefound(String _name,String _macaddress) throws Exception{
RDebugUtils.currentModule="main";
if (Debug.shouldDelegate("ble_devicefound"))
	return (String) Debug.delegate(mostCurrent.activityBA, "ble_devicefound", new Object[] {_name,_macaddress});
RDebugUtils.currentLine=786432;
 //BA.debugLineNum = 786432;BA.debugLine="Sub ble_DeviceFound (Name As String, MacAddress As";
RDebugUtils.currentLine=786433;
 //BA.debugLineNum = 786433;BA.debugLine="Log(Name & \", \" & MacAddress)";
anywheresoftware.b4a.keywords.Common.Log(_name+", "+_macaddress);
RDebugUtils.currentLine=786434;
 //BA.debugLineNum = 786434;BA.debugLine="listBLEDevicesName.Add(Name)";
mostCurrent._listbledevicesname.Add((Object)(_name));
RDebugUtils.currentLine=786435;
 //BA.debugLineNum = 786435;BA.debugLine="listBLEDevicesMacAdress.Add(MacAddress)";
mostCurrent._listbledevicesmacadress.Add((Object)(_macaddress));
RDebugUtils.currentLine=786436;
 //BA.debugLineNum = 786436;BA.debugLine="Log(\"Name : \" & Name & \"  MAC : \" & MacAddress)";
anywheresoftware.b4a.keywords.Common.Log("Name : "+_name+"  MAC : "+_macaddress);
RDebugUtils.currentLine=786437;
 //BA.debugLineNum = 786437;BA.debugLine="If Name.Contains (\"HM\") Then";
if (_name.contains("HM")) { 
RDebugUtils.currentLine=786438;
 //BA.debugLineNum = 786438;BA.debugLine="If ConnectState = cstateDisconnect Then";
if (_connectstate==_cstatedisconnect) { 
RDebugUtils.currentLine=786439;
 //BA.debugLineNum = 786439;BA.debugLine="ConnectState = cstatePreConnect";
_connectstate = _cstatepreconnect;
RDebugUtils.currentLine=786440;
 //BA.debugLineNum = 786440;BA.debugLine="Manager.Connect(MacAddress, True)";
_manager.Connect(_macaddress,anywheresoftware.b4a.keywords.Common.True);
 };
 };
RDebugUtils.currentLine=786443;
 //BA.debugLineNum = 786443;BA.debugLine="End Sub";
return "";
}
public static String  _ble_disconnected() throws Exception{
RDebugUtils.currentModule="main";
if (Debug.shouldDelegate("ble_disconnected"))
	return (String) Debug.delegate(mostCurrent.activityBA, "ble_disconnected", null);
RDebugUtils.currentLine=983040;
 //BA.debugLineNum = 983040;BA.debugLine="Sub ble_Disconnected";
RDebugUtils.currentLine=983041;
 //BA.debugLineNum = 983041;BA.debugLine="ConnectState = cstateDisconnect";
_connectstate = _cstatedisconnect;
RDebugUtils.currentLine=983042;
 //BA.debugLineNum = 983042;BA.debugLine="Manager.refreshDeviceCache";
_manager.refreshDeviceCache();
RDebugUtils.currentLine=983043;
 //BA.debugLineNum = 983043;BA.debugLine="Manager.Close";
_manager.Close();
RDebugUtils.currentLine=983044;
 //BA.debugLineNum = 983044;BA.debugLine="Log(\"Disconnected\")";
anywheresoftware.b4a.keywords.Common.Log("Disconnected");
RDebugUtils.currentLine=983045;
 //BA.debugLineNum = 983045;BA.debugLine="End Sub";
return "";
}
public static String  _ble_discoveryfinished() throws Exception{
RDebugUtils.currentModule="main";
if (Debug.shouldDelegate("ble_discoveryfinished"))
	return (String) Debug.delegate(mostCurrent.activityBA, "ble_discoveryfinished", null);
int _res = 0;
RDebugUtils.currentLine=851968;
 //BA.debugLineNum = 851968;BA.debugLine="Sub ble_DiscoveryFinished";
RDebugUtils.currentLine=851969;
 //BA.debugLineNum = 851969;BA.debugLine="Log(\"Search finished\")";
anywheresoftware.b4a.keywords.Common.Log("Search finished");
RDebugUtils.currentLine=851970;
 //BA.debugLineNum = 851970;BA.debugLine="If listBLEDevicesName.Size <> 0 Then";
if (mostCurrent._listbledevicesname.getSize()!=0) { 
RDebugUtils.currentLine=851971;
 //BA.debugLineNum = 851971;BA.debugLine="Dim res As Int";
_res = 0;
RDebugUtils.currentLine=851972;
 //BA.debugLineNum = 851972;BA.debugLine="res = InputList(listBLEDevicesName, \"Choose devi";
_res = anywheresoftware.b4a.keywords.Common.InputList(mostCurrent._listbledevicesname,"Choose device",(int) (-1),mostCurrent.activityBA);
RDebugUtils.currentLine=851973;
 //BA.debugLineNum = 851973;BA.debugLine="If res <> DialogResponse.CANCEL Then";
if (_res!=anywheresoftware.b4a.keywords.Common.DialogResponse.CANCEL) { 
RDebugUtils.currentLine=851974;
 //BA.debugLineNum = 851974;BA.debugLine="If ConnectState = cstateDisconnect Then";
if (_connectstate==_cstatedisconnect) { 
RDebugUtils.currentLine=851975;
 //BA.debugLineNum = 851975;BA.debugLine="ConnectState = cstatePreConnect";
_connectstate = _cstatepreconnect;
RDebugUtils.currentLine=851976;
 //BA.debugLineNum = 851976;BA.debugLine="Manager.Connect(listBLEDevicesMacAdress.Get(re";
_manager.Connect(BA.ObjectToString(mostCurrent._listbledevicesmacadress.Get(_res)),anywheresoftware.b4a.keywords.Common.True);
 };
 };
 }else {
RDebugUtils.currentLine=851980;
 //BA.debugLineNum = 851980;BA.debugLine="Msgbox2(\"Check Bluetooth and device is turned on";
anywheresoftware.b4a.keywords.Common.Msgbox2("Check Bluetooth and device is turned on and try again.","Connection error","OK","","",(android.graphics.Bitmap)(anywheresoftware.b4a.keywords.Common.LoadBitmap(anywheresoftware.b4a.keywords.Common.File.getDirAssets(),"error.png").getObject()),mostCurrent.activityBA);
 };
RDebugUtils.currentLine=851982;
 //BA.debugLineNum = 851982;BA.debugLine="End Sub";
return "";
}
public static String  _btndisconnect_click() throws Exception{
RDebugUtils.currentModule="main";
if (Debug.shouldDelegate("btndisconnect_click"))
	return (String) Debug.delegate(mostCurrent.activityBA, "btndisconnect_click", null);
RDebugUtils.currentLine=1179648;
 //BA.debugLineNum = 1179648;BA.debugLine="Sub btnDisconnect_Click";
RDebugUtils.currentLine=1179649;
 //BA.debugLineNum = 1179649;BA.debugLine="Manager.Disconnect";
_manager.Disconnect();
RDebugUtils.currentLine=1179650;
 //BA.debugLineNum = 1179650;BA.debugLine="End Sub";
return "";
}
public static String  _btnf1_click() throws Exception{
RDebugUtils.currentModule="main";
if (Debug.shouldDelegate("btnf1_click"))
	return (String) Debug.delegate(mostCurrent.activityBA, "btnf1_click", null);
RDebugUtils.currentLine=1638400;
 //BA.debugLineNum = 1638400;BA.debugLine="Sub btnF1_Click";
RDebugUtils.currentLine=1638401;
 //BA.debugLineNum = 1638401;BA.debugLine="EditText1.Text = \"1,\" & EditText2.Text & \",*\"			'";
mostCurrent._edittext1.setText((Object)("1,"+mostCurrent._edittext2.getText()+",*"));
RDebugUtils.currentLine=1638402;
 //BA.debugLineNum = 1638402;BA.debugLine="TX_Click";
_tx_click();
RDebugUtils.currentLine=1638403;
 //BA.debugLineNum = 1638403;BA.debugLine="End Sub";
return "";
}
public static String  _tx_click() throws Exception{
RDebugUtils.currentModule="main";
if (Debug.shouldDelegate("tx_click"))
	return (String) Debug.delegate(mostCurrent.activityBA, "tx_click", null);
String _txstring = "";
RDebugUtils.currentLine=1114112;
 //BA.debugLineNum = 1114112;BA.debugLine="Sub TX_Click";
RDebugUtils.currentLine=1114113;
 //BA.debugLineNum = 1114113;BA.debugLine="RX.Text = \"\"														'send to PIC";
mostCurrent._rx.setText((Object)(""));
RDebugUtils.currentLine=1114114;
 //BA.debugLineNum = 1114114;BA.debugLine="Dim TxString As String";
_txstring = "";
RDebugUtils.currentLine=1114116;
 //BA.debugLineNum = 1114116;BA.debugLine="TxString = EditText1.Text";
_txstring = mostCurrent._edittext1.getText();
RDebugUtils.currentLine=1114118;
 //BA.debugLineNum = 1114118;BA.debugLine="If ConnectState = cstateConnect Then";
if (_connectstate==_cstateconnect) { 
RDebugUtils.currentLine=1114119;
 //BA.debugLineNum = 1114119;BA.debugLine="Log(\"Write -> \" & TxString)";
anywheresoftware.b4a.keywords.Common.Log("Write -> "+_txstring);
RDebugUtils.currentLine=1114120;
 //BA.debugLineNum = 1114120;BA.debugLine="writeCharacteristic.SetStringValue(TxString)";
_writecharacteristic.SetStringValue(_txstring);
RDebugUtils.currentLine=1114121;
 //BA.debugLineNum = 1114121;BA.debugLine="Manager.WriteCharacteristic(writeCharacteristic)";
_manager.WriteCharacteristic(_writecharacteristic);
 }else {
RDebugUtils.currentLine=1114123;
 //BA.debugLineNum = 1114123;BA.debugLine="connectBT_Click";
_connectbt_click();
 };
RDebugUtils.currentLine=1114125;
 //BA.debugLineNum = 1114125;BA.debugLine="End Sub";
return "";
}
public static String  _btnf2_click() throws Exception{
RDebugUtils.currentModule="main";
if (Debug.shouldDelegate("btnf2_click"))
	return (String) Debug.delegate(mostCurrent.activityBA, "btnf2_click", null);
RDebugUtils.currentLine=1703936;
 //BA.debugLineNum = 1703936;BA.debugLine="Sub btnF2_Click";
RDebugUtils.currentLine=1703937;
 //BA.debugLineNum = 1703937;BA.debugLine="EditText1.Text = \"2,\" & EditText4.Text & \",*\"";
mostCurrent._edittext1.setText((Object)("2,"+mostCurrent._edittext4.getText()+",*"));
RDebugUtils.currentLine=1703938;
 //BA.debugLineNum = 1703938;BA.debugLine="TX_Click";
_tx_click();
RDebugUtils.currentLine=1703939;
 //BA.debugLineNum = 1703939;BA.debugLine="End Sub";
return "";
}
public static String  _btnf3_click() throws Exception{
RDebugUtils.currentModule="main";
if (Debug.shouldDelegate("btnf3_click"))
	return (String) Debug.delegate(mostCurrent.activityBA, "btnf3_click", null);
RDebugUtils.currentLine=1769472;
 //BA.debugLineNum = 1769472;BA.debugLine="Sub btnF3_Click";
RDebugUtils.currentLine=1769473;
 //BA.debugLineNum = 1769473;BA.debugLine="EditText1.Text = \"3,\" & EditText5.Text & \",*\"";
mostCurrent._edittext1.setText((Object)("3,"+mostCurrent._edittext5.getText()+",*"));
RDebugUtils.currentLine=1769474;
 //BA.debugLineNum = 1769474;BA.debugLine="TX_Click";
_tx_click();
RDebugUtils.currentLine=1769475;
 //BA.debugLineNum = 1769475;BA.debugLine="End Sub";
return "";
}
public static String  _btnstar_click() throws Exception{
RDebugUtils.currentModule="main";
if (Debug.shouldDelegate("btnstar_click"))
	return (String) Debug.delegate(mostCurrent.activityBA, "btnstar_click", null);
RDebugUtils.currentLine=1507328;
 //BA.debugLineNum = 1507328;BA.debugLine="Sub btnStar_Click";
RDebugUtils.currentLine=1507329;
 //BA.debugLineNum = 1507329;BA.debugLine="EditText1.Text = \"0,*\"";
mostCurrent._edittext1.setText((Object)("0,*"));
RDebugUtils.currentLine=1507330;
 //BA.debugLineNum = 1507330;BA.debugLine="TX_Click";
_tx_click();
RDebugUtils.currentLine=1507331;
 //BA.debugLineNum = 1507331;BA.debugLine="End Sub";
return "";
}
public static String  _pwroff_click() throws Exception{
RDebugUtils.currentModule="main";
if (Debug.shouldDelegate("pwroff_click"))
	return (String) Debug.delegate(mostCurrent.activityBA, "pwroff_click", null);
RDebugUtils.currentLine=1835008;
 //BA.debugLineNum = 1835008;BA.debugLine="Sub PWROFF_Click";
RDebugUtils.currentLine=1835009;
 //BA.debugLineNum = 1835009;BA.debugLine="EditText1.Text = \"5,*\"";
mostCurrent._edittext1.setText((Object)("5,*"));
RDebugUtils.currentLine=1835010;
 //BA.debugLineNum = 1835010;BA.debugLine="TX_Click";
_tx_click();
RDebugUtils.currentLine=1835011;
 //BA.debugLineNum = 1835011;BA.debugLine="End Sub";
return "";
}
public static String  _rx_longclick() throws Exception{
RDebugUtils.currentModule="main";
if (Debug.shouldDelegate("rx_longclick"))
	return (String) Debug.delegate(mostCurrent.activityBA, "rx_longclick", null);
RDebugUtils.currentLine=1310720;
 //BA.debugLineNum = 1310720;BA.debugLine="Sub RX_LongClick";
RDebugUtils.currentLine=1310721;
 //BA.debugLineNum = 1310721;BA.debugLine="RX.Text = \"\"";
mostCurrent._rx.setText((Object)(""));
RDebugUtils.currentLine=1310722;
 //BA.debugLineNum = 1310722;BA.debugLine="End Sub";
return "";
}
public static String  _send_click() throws Exception{
RDebugUtils.currentModule="main";
if (Debug.shouldDelegate("send_click"))
	return (String) Debug.delegate(mostCurrent.activityBA, "send_click", null);
RDebugUtils.currentLine=1245184;
 //BA.debugLineNum = 1245184;BA.debugLine="Sub SEND_Click";
RDebugUtils.currentLine=1245186;
 //BA.debugLineNum = 1245186;BA.debugLine="End Sub";
return "";
}
public static String  _send4_click() throws Exception{
RDebugUtils.currentModule="main";
if (Debug.shouldDelegate("send4_click"))
	return (String) Debug.delegate(mostCurrent.activityBA, "send4_click", null);
RDebugUtils.currentLine=1376256;
 //BA.debugLineNum = 1376256;BA.debugLine="Sub Send4_Click";
RDebugUtils.currentLine=1376257;
 //BA.debugLineNum = 1376257;BA.debugLine="EditText1.Text = (send_code + 4) &  \",\"	& EditTex";
mostCurrent._edittext1.setText((Object)(BA.NumberToString((_send_code+4))+","+mostCurrent._edittext3.getText()+",*"));
RDebugUtils.currentLine=1376258;
 //BA.debugLineNum = 1376258;BA.debugLine="TX_Click";
_tx_click();
RDebugUtils.currentLine=1376259;
 //BA.debugLineNum = 1376259;BA.debugLine="End Sub";
return "";
}
public static String  _send6_click() throws Exception{
RDebugUtils.currentModule="main";
if (Debug.shouldDelegate("send6_click"))
	return (String) Debug.delegate(mostCurrent.activityBA, "send6_click", null);
RDebugUtils.currentLine=1441792;
 //BA.debugLineNum = 1441792;BA.debugLine="Sub Send6_Click";
RDebugUtils.currentLine=1441793;
 //BA.debugLineNum = 1441793;BA.debugLine="EditText1.Text = \"6,*\"";
mostCurrent._edittext1.setText((Object)("6,*"));
RDebugUtils.currentLine=1441794;
 //BA.debugLineNum = 1441794;BA.debugLine="TX_Click";
_tx_click();
RDebugUtils.currentLine=1441795;
 //BA.debugLineNum = 1441795;BA.debugLine="End Sub";
return "";
}
public static String  _timer1_tick() throws Exception{
RDebugUtils.currentModule="main";
if (Debug.shouldDelegate("timer1_tick"))
	return (String) Debug.delegate(mostCurrent.activityBA, "timer1_tick", null);
RDebugUtils.currentLine=655360;
 //BA.debugLineNum = 655360;BA.debugLine="Sub timer1_tick";
RDebugUtils.currentLine=655361;
 //BA.debugLineNum = 655361;BA.debugLine="send_T = send_T + 1";
_send_t = (int) (_send_t+1);
RDebugUtils.currentLine=655362;
 //BA.debugLineNum = 655362;BA.debugLine="If send_T = send_max Then";
if (_send_t==_send_max) { 
RDebugUtils.currentLine=655363;
 //BA.debugLineNum = 655363;BA.debugLine="send_T = 0";
_send_t = (int) (0);
 };
RDebugUtils.currentLine=655367;
 //BA.debugLineNum = 655367;BA.debugLine="Select ConnectState";
switch (_connectstate) {
case 0: {
RDebugUtils.currentLine=655369;
 //BA.debugLineNum = 655369;BA.debugLine="TX.Color = Colors.Red";
mostCurrent._tx.setColor(anywheresoftware.b4a.keywords.Common.Colors.Red);
RDebugUtils.currentLine=655370;
 //BA.debugLineNum = 655370;BA.debugLine="TX.Text = \"Connect\"";
mostCurrent._tx.setText((Object)("Connect"));
 break; }
case 1: {
RDebugUtils.currentLine=655372;
 //BA.debugLineNum = 655372;BA.debugLine="TX.Color = Colors.Blue";
mostCurrent._tx.setColor(anywheresoftware.b4a.keywords.Common.Colors.Blue);
RDebugUtils.currentLine=655373;
 //BA.debugLineNum = 655373;BA.debugLine="TX.Text = \"Connecting\"";
mostCurrent._tx.setText((Object)("Connecting"));
 break; }
case 2: {
RDebugUtils.currentLine=655375;
 //BA.debugLineNum = 655375;BA.debugLine="TX.Color = Colors.Green";
mostCurrent._tx.setColor(anywheresoftware.b4a.keywords.Common.Colors.Green);
RDebugUtils.currentLine=655376;
 //BA.debugLineNum = 655376;BA.debugLine="TX.Text = \"Send\"";
mostCurrent._tx.setText((Object)("Send"));
 break; }
}
;
RDebugUtils.currentLine=655378;
 //BA.debugLineNum = 655378;BA.debugLine="End Sub";
return "";
}
}